"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tap = exports.concat = exports.run = void 0;
const tslib_1 = require("tslib");
function run(tasks) {
    return (config) => concat(tasks)(config);
}
exports.run = run;
function concat(processes) {
    return function (r) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return yield processes.reduce((cfg, processor) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () { return yield processor(yield cfg); }), Promise.resolve(r));
        });
    };
}
exports.concat = concat;
function tap(process) {
    return function (d) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            yield process(d);
            return Promise.resolve(d);
        });
    };
}
exports.tap = tap;
//# sourceMappingURL=behaviors.js.map