import * as yargs from 'yargs';
import { Options } from 'yargs';
import { YargsCommandObject } from './types';
import { RcArgvOptions, RcJson } from '../../../types';
export declare function setupYargs(commands: YargsCommandObject[], options: {
    [key: string]: Options;
}, config?: Record<string, any>): yargs.Argv<{}>;
export declare function runCli(cliCfg: {
    commands: YargsCommandObject[];
    options: {
        [key: string]: Options;
    };
    config: Record<string, any>;
}): void;
export declare function getCLIConfigFromArgv(argv: RcArgvOptions): RcJson;
